// Copyright (c) 2018 Kerlink SA. All rights reserved.

#ifndef _COMMON_CONFIG_H_
#define _COMMON_CONFIG_H_

#include "third-party/parson.h"

#include "utils/stringlist.h"

#include "core.h"

struct config_core;

struct config_core *config_core_init(void);
int config_core_parse(struct core *core, JSON_Object *root);
int config_core_apply(struct core *core);
void config_core_free(struct core *core);

struct config {
	struct config_core *core;
	struct stringlist api_uplinks;
	struct stringlist api_downlinks;
	struct stringlist api_controls;
};

struct config *config_init(void);
int config_parse_file(struct core *core, const char *filename);
int config_apply(struct core *core);
void config_free(struct core *core);

#endif
