// Copyright (c) 2018 Kerlink SA. All rights reserved.

#ifndef _CORE_CONFIG_H_
#define _CORE_CONFIG_H_

#include <stdint.h>
#include <sys/types.h>

#include "lib/loragw/hal.h"

#include "common/config.h"

struct config_core {
	double antenna_gain;
	double insertion_loss;
	struct lgw_conf_board_s board;
	struct lgw_conf_lbt_s lbt;
	struct lgw_tx_gain_lut_s txlut;
	struct lgw_conf_rxrf_s rxrf[LGW_RF_CHAIN_NB];
	struct lgw_conf_rxif_s rxif[LGW_IF_CHAIN_NB];
	struct rfchain {
		uint32_t tx_freq_min;
		uint32_t tx_freq_max;
	} rfchains[LGW_RF_CHAIN_NB];
	struct config_beacon {
		int enable;
		uint32_t period;
		uint32_t frequency;
		uint32_t frequency_step;
		size_t frequencies;
		uint8_t bandwidth;
		uint32_t spreading_factor;
		int8_t power;
		uint8_t infodesc;
		double latitude;
		double longitude;
	} beacon;
};

#endif
