// Copyright (c) 2018 Kerlink SA. All rights reserved.

#ifndef _CORE_CONFIG_H_
#define _CORE_CONFIG_H_

#include <sys/types.h>

#include "lib/sx1301ar/hal.h"

#include "common/config.h"

struct config_core {
	size_t nb_boards;
	struct config_board {
		sx1301ar_board_cfg_t board;
		sx1301ar_lbt_cfg_t lbt;
		struct config_chip {
			sx1301ar_chip_cfg_t chip;
			sx1301ar_chan_cfg_t chans[SX1301AR_CHIP_CHAN_NB];
		} chips[SX1301AR_BOARD_CHIPS_NB];
		struct config_rfchain {
			uint32_t tx_freq_min;
			uint32_t tx_freq_max;
		} rfchains[SX1301AR_BOARD_RFCHAIN_NB];
	} boards[SX1301AR_MAX_BOARD_NB];
	struct config_beacon {
		int enable;
		uint32_t period;
		uint32_t frequency;
		uint32_t frequency_step;
		size_t frequencies;
		sx1301ar_bandw_t bandwidth;
		sx1301ar_modr_t spreading_factor;
		int8_t power;
		uint8_t infodesc;
		double latitude;
		double longitude;
	} beacon;
};

#endif
